mod Ex02a

incl Mtex

incl Maux

loc rem 
  \para \bf  2. CVIČENIE Z PREDMETU 1-INF-465 DEKLARATÍVNE PROGRAMOVANIE  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Dátum:  \end piatok 25.2.2011 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-465-dp/1011ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované rekurzii s 
  mierou a definíciam predikátov. Zadanie sa skladá z týchto súborov: 
  \items 
   \item \para Súbory \it  mtex*.cl  \end obsahujú makrá pre CL-TeX. 
   \item \para Súbory \it  maux*.cl  \end obsahujú definície a vlastnosti 
         pomocných funkcií a predikátov. 
   \item \para Súbory \it  ex*.cl  \end obsahujú úlohy, ktoré máte riešiť 
         na tomto cvičení. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje základnú syntax systému 
         CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
   \item \para \it  [2]  \end J. Kľuka. Lecture Notes from Introduction to 
         Declarative Programming Summer 2010/11. 
  \end

rem 
  \para \bf  Chapter. Numeric Programs.  \end 

rem 
  \para \bf  Section. Course of Values Recursion.  \end 

rem 
  \para \bf  Fibonacci sequence.  \end \header* fun Fib 'Tex_f1_n_fib' \end 
  Specification of the function \ft Fib(n) \end computing the \ft n \end-th 
  element of the Fibonacci sequence: 
  \eq* 
    Fib(0) = 0
  \end
  \eq* 
    Fib(1) = 1
  \end
  \eq* 
    Fib(n+2) = Fib(n+1)+Fib(n)
  \end
  \para Find a course of values recursive definition of \ft Fib(n) \end. 

fun Fib 'Tex_f1_n_fib'
  Fib(n) = Foo

rem 
  \para \bf  Integer division.  \end Specification of the integer division 
  function \ft x/y \end: 
  \eq* 
    x/0 = 0
  \end
  \eq* 
    y != 0 -> \e r(x = x/y*y+r & r < y)
  \end
  \para Find a course of values recursive definition of \ft x/y \end. 

fun/2 Div 'Tex_f2_n_div'
  Div(x,y) = Foo

rem 
  \para \bf  Remainder.  \end Specification of the remainder function 
  \ft x mod y \end: 
  \eq* 
    x mod 0 = 0
  \end
  \eq* 
    y != 0 -> \e q(x = q*y+x mod y & x mod y < y)
  \end
  \para Find a course of values recursive definition of \ft x mod y \end. 

fun/2 Mod 'Tex_f2_n_mod'
  Mod(x,y) = Foo

rem 
  \para \bf  Subsection. Course of Values Recursion with Substitution in 
  Parameters.  \end 

rem 
  \para \bf  Divisibility predicate.  \end 

pred/2 Divides 'Tex_p2_n_divides'
  Divides(x,y) <-> \e z y = x*z

rem 
  \para \bf  Greatest common divisor.  \end 
  \header* fun/2 Gcd 'Tex_f2_n_gcd' \end Specification of the greatest common 
  divisor function \ft Gcd(x,y) \end: 
  \eq* 
    x != 0 \/ y != 0 -> Divides(Gcd(x,y),x) & Divides(Gcd(x,y),y)
  \end
  \eq* 
    (x != 0 \/ y != 0) & Divides(z,x) & Divides(z,y) -> z <= Gcd(x,y)
  \end

rem 
  \para \bf  Euclidean algorithm I.  \end \header* fun/2 Gcd 'Tex_f2_n_gcd' \end 
  Find a course of values recursive definition of \ft Gcd(x,y) \end based on the 
  property 
  \eq* 
    x != 0 & Divides(z,x) -> Divides(z,y) <-> Divides(z,y mod x)
  \end

fun/2 Gcd1 'Tex_f2_n_gcd'
  Gcd1(x,y) = Foo

rem 
  \para \bf  Subsection. Course of Values Recursion with Measure.  \end 

rem 
  \para \bf  Euclidean algorithm II.  \end 
  \header* fun/2 Gcd 'Tex_f2_n_gcd' \end Find a course of values recursive 
  definition of \ft Gcd(x,y) \end based on the property 
  \eq* 
    x < y & Divides(z,x) -> Divides(z,y) <-> Divides(z,y-x)
  \end
  \para \it  [CL] Remark.  \end Note that we have 
  \eq* 
    x = 0 \/ y = 0 -> Gcd(x,y) = Max(x,y)
  \end

fun/2 Gcd2 'Tex_f2_n_gcd'
  Gcd2(x,y) = Max(x,y) <- x = 0
  Gcd2(x,y) = Max(x,y) <- x != 0 & y = 0
  Gcd2(x,y) = Foo <- x != 0 & y != 0

